unit UdmXml;

// |===========================================================================|
// | unit UdmXml                                                               |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unit de gestion des fichiers XML pour le logiciel FBPING                 |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0 Cration de l'unit                                               |
// |===========================================================================|


interface

uses
  SysUtils, Classes, xmldom, XMLIntf, msxmldom, XMLDoc;

type
  TdtXML = class(TDataModule)
    XMLDoc: TXMLDocument;
  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    procedure Charger(strnomfichier : string);
    procedure Sauver(strNomfichier : string);
  end;

var
  dtXML: TdtXML;

implementation

{$R *.dfm}
uses ufrmmaitre,ufrmentite, Controls,dialogs;

procedure TdtXML.Charger (strNomfichier : string);

//  ___________________________________________________________________________
// | procedure TdtXML.Charger                                                  |
// | _________________________________________________________________________ |
// || Permet de charger un fichier projet et de crer les entits             ||
// ||_________________________________________________________________________||
// || Entres | strNomfichier : string                                        ||
// ||         |   nom du fichier  ouvrir                                     ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i,j : integer;
  xmlFichier : IXMLNode ;
  xmlEntite : IXMLNode ;
  xmlOption : IXMLNode ;
  def : IXMLNode ;
  information : tmachine;

begin
  XMLDoc.LoadFromFile(strnomfichier );

// ****************************************************************************
// * Verification du type de fichier le premier noeud doit tre 'fb_ping_data'*
// ****************************************************************************

  if XMLDoc.DocumentElement.LocalName  = 'fb_ping_data' then
  begin

// ****************************************************************************
// * Lecture de tous les sous noeud                                           *
// ****************************************************************************

    for i := 0 to  XMLDoc.DocumentElement.ChildNodes.Count -1 do
    begin
      xmlfichier := XMLDoc.DocumentElement.ChildNodes [i];

// ****************************************************************************
// * Le sous noeud est un Elements on liste ses sous noeud pour crer les     *
// * entits                                                                  *
// ****************************************************************************

      if xmlfichier.NodeName ='Elements' then
        for j := 0 to xmlFichier.ChildNodes.Count - 1 do
        begin
          xmlEntite := xmlFichier.ChildNodes[j];
          if xmlEntite.NodeName = 'Element' then
          begin
            information.strNom := xmlEntite.Attributes ['nom'];
            information.strhost := xmlEntite.Attributes ['host'];
            information.strCommentaire := xmlEntite.Attributes ['commentaire'];
            information.booControler := xmlEntite.Attributes ['monitoring'];
            information.typeMachine := xmlEntite.Attributes ['type'];
            information.x := xmlEntite.Attributes['x'];
            information.y := xmlEntite.Attributes['y'];
            TfrmEntite.create(frmmaitre,information);
          end;
        end;

// ****************************************************************************
// * Le sous noeud est une Options charge les options d'envoie de mail        *
// ****************************************************************************

      if xmlfichier.NodeName ='Options' then
      begin
        xmlOption := xmlfichier.ChildNodes['Option'];
        frmmaitre.Fboptions.booMail := xmlOption.Attributes['SendMail'];
        frmmaitre.Fboptions.strFrom := xmlOption.Attributes['From'];
        setlength(frmmaitre.Fboptions.tabStrMail,xmloption.ChildNodes.Count);
        for j := 0 to xmloption.ChildNodes.Count -1 do
        begin
          def := xmlOption.ChildNodes[j];
          frmmaitre.Fboptions.tabStrMail[j] := def.NodeValue ;
        end;
      end;
    end;
  end else
    messagedlg('Le fichier ' + strnomfichier +  #10 + #13 +
               'ne semble pas tre un fichier fbPing valide',
               mterror,[mbok],0);
end;

procedure TdtXML.Sauver (strNomfichier : string);

//  ___________________________________________________________________________
// | procedure TdtXML.Sauver                                                   |
// | _________________________________________________________________________ |
// || Permet de sauvegarder le projet dans un fichier                         ||
// ||_________________________________________________________________________||
// || Entres | strNomfichier : string                                        ||
// ||         |   nom du fichier dans le quel sauvegarder le projet           ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  xmlFichier : IXMLNode ;
  xmlEntite : IXMLNode ;
  xmlOption : IXMLNode ;
  def : IXMLNode ;
  i : integer;
  information : tmachine;

begin
  XMLDoc.active := false;
  XMLDoc.FileName :='';
  XMLDoc.XML.clear;
  XMLDOC.Active :=true;
  XMLDoc.Version :='1.0';
  XMLDoc.StandAlone :='no';
  XMLDoc.encoding   := 'UTF-8';
  XMLDoc.DocumentElement := XMLDoc.CreateElement('fb_ping_data','');

// ****************************************************************************
// * Sauvegarde des options d'envoie de mail dans le noeud Options            *
// ****************************************************************************

  xmlFichier := XMLDoc.DocumentElement.AddChild('Options');
  xmlOption :=xmlFichier.AddChild('Option');
  xmlOption.SetAttributeNS('SendMail','',frmmaitre.Fboptions.booMail );
  xmlOption.SetAttributeNS('From','',frmmaitre.Fboptions.strFrom  );
  for i:=0 to length(frmmaitre.Fboptions.tabStrMail) -1 do
  begin
    def := xmlOption.AddChild('To');
    def.Text := frmmaitre.Fboptions.tabStrMail[i];
  end;

// ****************************************************************************
// * Sauvegarde des entits dans le noeud Elements                            *
// ****************************************************************************

  xmlFichier := XMLDoc.DocumentElement.AddChild('Elements');
  for i := 0 to frmmaitre.ControlCount -1 do
    if frmmaitre.Controls[i] is TfrmEntite then
    begin

// ****************************************************************************
// * Sauvegarde des proprits de l'entit dans le sous noeud Element         *
// ****************************************************************************

      information := TfrmEntite (frmmaitre.Controls[i]).getInfo ;
      xmlEntite := xmlFichier.AddChild('Element');
      xmlEntite.SetAttributeNS('nom','',information.strnom );
      xmlEntite.SetAttributeNS('host','',information.strhost );
      xmlEntite.SetAttributeNS('commentaire','',information.strcommentaire );
      xmlEntite.SetAttributeNS('type','',information.typeMachine );
      xmlEntite.SetAttributeNS('monitoring','',information.booControler );
      xmlEntite.SetAttributeNS('x','',information.x );
      xmlEntite.SetAttributeNS('y','',information.y );
    end;
  XMLDoc.SaveToFile(strNomfichier );
end;

end.
