unit UfonctionsDiv;

// |===========================================================================|
// | unit UfonctionsDiv                                                        |
// | Copyright  2006 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unit UfonctionsDiv contenant divers fonctions                            |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Version 1.0.0.0 Cration de l'unit                                       |
// |===========================================================================|


interface
uses winsvc,classes;
type
  PNTServices = ^TNTServices ;
  TNTServices = array[0..512] of TEnumServiceStatus;

  function  StrLectureVersion : String;
  Function  StrLectureNomProduit : String;
  Function  StrLectureCopyright : String;
  Procedure EcritLog ( strLog : string ) ;

implementation

uses sysutils, windows ,forms,URLMon,inifiles,HtmlHelpAPI;

Function StrLectureVersion : String;

//  ___________________________________________________________________________
// | function  StrLectureVersion                                               |
// | _________________________________________________________________________ |
// || Permet d'avoir le numero de version de l'appli                          ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Version de l'appli                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Rservation en mmoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\FileVersion'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;

Function StrLectureNomProduit : String;

//  ___________________________________________________________________________
// | function  StrLectureNomProduit                                            |
// | _________________________________________________________________________ |
// || Permet d'avoir le nom de l'appli                                        ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Nom de l'appli                                              ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Rservation en mmoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\InternalName'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;

Function StrLectureCopyright : String;

//  ___________________________________________________________________________
// | function  StrLectureCopyright                                             |
// | _________________________________________________________________________ |
// || Permet d'avoir le Copyright de l'appli                                  ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Copyright de l'appli                                        ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Rservation en mmoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\LegalCopyright'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;

Procedure EcritLog ( strLog : string ) ;

//  ___________________________________________________________________________
// | procedure ecritlog                                                        |
// | _________________________________________________________________________ |
// || permet d'crire dans un fichier log                                     ||
// ||_________________________________________________________________________||
// || Entres | strLog : string                                               ||
// ||         |   text  ajouter au fichier                                   ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  fichier : textfile;
  strNomfichier : string;
begin
  try
    strNomfichier := ChangeFileExt(Application.ExeName ,'.log');
    strLog := DateTimeToStr(Now )+ ' : ' + strLog;
    assignfile(fichier ,strNomfichier);
    if FileExists (strNomfichier) then
      append(fichier) else
      rewrite(fichier);
    writeln(fichier,strLog);
    CloseFile (fichier );
  except
  end;
end;

end.
