unit uMail;

// |===========================================================================|
// | unit uMail                                                                |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unite permetant l'envoie par mail de l'tat des entits                   |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// | 1.0.0 Cration de l'unit utilisation de INDY 10.1.5                      |
// |===========================================================================|


interface
type
  Tmessage = record
    intPortSmtp : integer;                      // port du serveur SMTP
    strAddrSmtp : string;                       // Adresse du serveur SMTP
    strFrom     : string;                       // adresse de l'expediteur
    tabStrTo    : array of string;              // liste des adresses de destinations
    strMessage  : string;                       // Message
  end;
  procedure envoyerMail(infoMessage:Tmessage );

implementation
uses
  IdMessageClient, IdSMTPBase, IdSMTP,IdMessage,sysutils,ufonctionsdiv;
var
  smtp: TIdSMTP;
  message1: TIdMessage;

procedure envoyerMail(infoMessage:Tmessage);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.envoyerMail                                          |
// | _________________________________________________________________________ |
// || Permet d'envoyer un mail avec la liste des lments inactif             ||
// ||_________________________________________________________________________||
// || Entres | strCorpsMessage : string                                      ||
// ||         |   message  envoyer                                           ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  nb,i : integer;
  strAdresse : string;
begin
  smtp := TIdSMTP.Create ;
  message1 := TIdMessage.Create ;

  nb := length(infoMessage.tabStrTo );
  if nb = 0 then exit;
  try
    smtp.AuthType := atnone;
    smtp.Port := infoMessage.intPortSmtp ;
    smtp.Host := infoMessage.strAddrSmtp ;
    smtp.Connect;
    message1.From.Text := infoMessage.strFrom ;
    message1.Subject := 'Element inactif';
    message1.Body.Text := infoMessage.strMessage + #13#10#13#10 +
                          'Ceci est un mail automatique cre par FBPING V' +
                          StrLectureVersion;
    stradresse := '';
    for i:= 0 to nb-1 do
      stradresse := stradresse + infoMessage.tabStrTo[i] + ';';
    message1.Recipients.EMailAddresses := strAdresse ;
    smtp.Send(message1);
  except
    on e:exception do
      ecritlog ('Il y a eu une erreur lors de l''envoie du message' + #13#10 +'  "'+ e.Message+'"' + #13#10 );
  end;
  if smtp.Connected then smtp.disconnect;
  message1.free;
  smtp.free;
end;


end.
