unit ufrmEntite;

// |===========================================================================|
// | unit ufrmEntite                                                           |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unite gerant les entits du logiciel FBPING                               |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0.0 Cration de l'unit                                             |
// |===========================================================================|


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ExtCtrls, ImgList,Uping,ufonctionsdiv;

type
  TtypeMachine = (tmImprimante,tmOrdinateur,tmServeur,tmSwitch);

  Tmachine = record
    typeMachine    : TtypeMachine ;
    strNom         : string;
    strHost        : string;
    strCommentaire : string;
    booControler   : boolean;
    x              : integer;
    y              : integer;
  end;

  TfrmEntite = class(TFrame)
    ImageList1: TImageList;
    Panel1: TPanel;
    Image1: TImage;
    lblNom: TLabel;
    lblIP: TLabel;
    Timer1: TTimer;
    lblreplymoyen: TLabel;
    lblTimereply: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure fDblClick(Sender: TObject);
    procedure fMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure fDragOver(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);
  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************
    information : tmachine;
    ping : tping;
    nbTimeOut : integer;
    procedure dessinerSelection(selection : boolean);
    procedure adaptetaille;
    procedure modifierHint ;
  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************
    constructor create (AOwner: TComponent;machine : Tmachine );
    destructor Destroy; override;
    class procedure setDistanceAvantDrag( valeur : integer );
    class procedure setTaillegrille( valeur : integer );
    class function getMessage : string;
    function getNom : string;
    function getstrType : string;
    function getInfo : Tmachine ;
    function booPing : boolean;
    function getBooControler : boolean;
  end;

//var

implementation

uses ufrmmaitre,ufrmsaisie;

var
  nbentite : integer;
  intDistanceAvantDrag : integer;
  intTaillegrille : integer;
  strmessage : string;
  MousePoint: TPoint;

{$R *.dfm}

constructor TfrmEntite.Create(AOwner: TComponent;machine :Tmachine );

//  ___________________________________________________________________________
// | constructor TfrmEntite.Create                                             |
// | _________________________________________________________________________ |
// || constructeur de la class Tfrmentite, permet de crer une entit avec les||
// |  information passes par machine                                         ||
// ||_________________________________________________________________________||
// || Entres | AOwner: TComponent                                            ||
// ||         |   objet parent de l'entit cre                               ||
// ||         | machine : Tmachine                                            ||
// ||         |   Information concernant l'entit                             ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  inherited create(AOwner);
  ImageList1.GetBitmap(ord(machine.typeMachine),Image1.Picture.Bitmap );
  information := machine;
  lblIP.caption := machine.strhost;
  lblNom.Caption := machine.strNom;
  hint := machine.strNom + #10+ #13 + '@IP : '+ machine.strhost + #10 + #13 + machine.strCommentaire ;
  parent :=twincontrol( aOwner);
  panel1.color := clwhite;
  nbentite := nbentite + 1;
  name := StringReplace(machine.strNom,' ','_',[rfReplaceAll , rfIgnoreCase ]);
  if not information.booControler then panel1.color := clLtGray ;
  if machine.x < 80 then left := 80 else left := machine.x;
  if machine.y < 0 then top := 0 else top := machine.y;
  adaptetaille;
  ping := tping.Create ;
  ping.SetAddress(information.strHost );
  ping.Timeout := 2000;
end;

destructor TfrmEntite.Destroy ;

//  ___________________________________________________________________________
// | destructor TfrmEntite.Destroy                                             |
// | _________________________________________________________________________ |
// || destructeur de la class TfrmEntite, permet de fermer l'objet Ping et de ||
// || dcrmenter le compteur d'entit                                        ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  FreeAndNil(ping);
  nbentite := nbentite - 1;
  inherited;
end;

class procedure TfrmEntite.setDistanceAvantDrag(valeur : integer);

//  ___________________________________________________________________________
// | class procedure TfrmEntite.setDistanceAvantDrag                           |
// | _________________________________________________________________________ |
// || Methode de class permetant de definir la valeur intDistanceAvantDrag    ||
// || contenant la valeur a partir de la quelle le drag commence              ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  intDistanceAvantDrag := valeur;
end;

class procedure TfrmEntite.setTaillegrille(valeur : integer);

//  ___________________________________________________________________________
// | class procedure TfrmEntite.setTaillegrille                                |
// | _________________________________________________________________________ |
// || Methode de class permetant de definir la valeur intTaillegrille         ||
// || contenant la taille de la grille pour le deplacement des entits        ||
// ||_________________________________________________________________________||
// || Entres | valeur : integer                                              ||
// ||         |   taille de la grille                                         ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if valeur > 0  then intTaillegrille := valeur;
end;

class function TfrmEntite.getMessage : string;

//  ___________________________________________________________________________
// | class function TfrmEntite.getMessage                                      |
// | _________________________________________________________________________ |
// || Methode de class permetant de recuprer la valeur de strMessage et de   ||
// || rinitialiser sa valeur                                                 ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := strmessage ;
  strmessage := '';
end;

procedure TfrmEntite.modifierHint;

//  ___________________________________________________________________________
// | procedure TfrmEntite.modifierHint                                         |
// | _________________________________________________________________________ |
// || Actualise le Hint de l'entit en fonction des valeurs strNom, strHost,  ||
// || strCommentaire et des temps de rponses                                 ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  hint := information.strNom + #10+ #13 +
          '@IP : '+ information.strhost + #10 + #13 +
          information.strCommentaire + #10 + #13 +
          'Rponse (ms) : '+ lblTimereply.caption  +  #10 + #13 +
          'Rponse moyen (ms) : ' + lblreplymoyen.Caption  ;
end;

function TfrmEntite.booPing : boolean;

//  ___________________________________________________________________________
// | function TfrmEntite.booPing                                               |
// | _________________________________________________________________________ |
// || permet de lancer un ping sur l'adresse de l'entit, en cas de deux ping ||
// || ngatifs conscutifs il y remplissage du message pour envoie de mail    ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : true                                                 ||
// ||         |   vrai si ping ok                                             ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := false;
  if information.booControler then
  begin
    panel1.Color := clTeal;
    application.ProcessMessages ;
    result := ping.Ping  <> 0 ;
    if result then
    begin
      panel1.Color := clLime;
      lblreplymoyen.Caption := FloatToStrF(ping.averageRTT,ffNumber ,7,2);
      lblTimereply.Caption := inttostr(ping.RTT );
      modifierHint;
      if nbTimeOut >0 then
      begin
        ecritlog (information.strNom + ' @:' + information.strHost + ' On Line');
        if nbTimeOut > 1 then
          strmessage := strmessage + information.strNom + ' @:' + information.strHost + ' est pass On Line  ' + datetimetostr(now())+ #13#10;
        nbTimeOut := 0 ;
      end;
    end else
    begin
      panel1.Color := clred;
      nbTimeOut := nbTimeOut +1;
      if nbTimeOut = 1 then ecritlog (information.strNom + ' @:' + information.strHost + ' Off Line');
      if nbTimeOut = 2 then
        strmessage := strmessage +'/!\ ' +  information.strNom + ' @:' + information.strHost +
                      ' est pass Off Line  ' + datetimetostr(now())+ #13#10 ;
    end;
  end;
end;

procedure TfrmEntite.adaptetaille ;

//  ___________________________________________________________________________
// | procedure TfrmEntite.adaptetaille                                         |
// | _________________________________________________________________________ |
// || permet de changer la taille en fonction du type de l'entit             ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if information.typeMachine = tmSwitch then
  begin
    Height := 69;
    image1.Height := 29;
  end else
  begin
    Height := 105;
    image1.Height := 64;
  end;
end;


procedure TfrmEntite.dessinerSelection(selection : boolean);

//  ___________________________________________________________________________
// | procedure TfrmEntite.dessinerSelection                                    |
// | _________________________________________________________________________ |
// || permet de dessiner une selection sur l'entit slectionne              ||
// ||_________________________________________________________________________||
// || Entres | selection : boolean                                           ||
// ||         |   vrai -> selectionne                                        ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if selection then panel1.BevelKind := bktile else panel1.BevelKind := bknone;
end;

procedure TfrmEntite.fDragOver(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);

//  ___________________________________________________________________________
// | procedure TfrmEntite.fDragOver                                            |
// | _________________________________________________________________________ |
// || permet de grer le dplacement de l'entit en fonction de la grille de  ||
// || la form Maitre                                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender : TObject                                              ||
// ||         |   objet recevant l'objet dplac                              ||
// ||         | Source : Tobject                                              ||
// ||         |   objet en cours de dplacement                               ||
// ||         | x,  y : integer                                               ||
// ||         |   coordonnes cran de l'objet dplac                        ||
// ||         | State : TDragState                                            ||
// ||         |   spcifie comment l'objet dplac se dplace au-dessus       ||
// ||         | Accept : Boolean                                              ||
// ||         |   autorise le dplacement au dessus de l'objet Sender         ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  tempPoint:TPoint;
  parentp : tpoint;
  T,L :integer;
begin
  getcursorpos(tempPoint);
  parentp :=(Parent as TControl).screentoclient(tempPoint);
  with (Source as TControl) do
  begin

  // **************************************************************************
  // * Calcul des points Top et Left en fonction de la grille                 *
  // **************************************************************************

    T:=Round((parentp.Y -MousePoint.Y)/intTaillegrille)*intTaillegrille;
    L:=Round((parentp.X -MousePoint.X)/intTaillegrille)*intTaillegrille;

  // **************************************************************************
  // * Limitation des points Top et Left en fonction du menu                  *
  // **************************************************************************

    if L < 80 then L := 80;
    if T < 0 then T := 0;
    top := t;
    left := l;

  // **************************************************************************
  // * Indication que le projet est modifi                                   *
  // **************************************************************************

    if (information.x <> left) or (information.y <>top ) then frmmaitre.cbxModif.Checked := true;
    information.x := left;
    information.y := top;
  end;
  Accept:=true;
end;

procedure TfrmEntite.fMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);

//  ___________________________________________________________________________
// | procedure TfrmEntite.fMouseDown                                           |
// | _________________________________________________________________________ |
// || Permet de dclencher le dplacement de l'entit sur un mouse down       ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||         | Button: TMouseButton                                          ||
// ||         |   etat des bouttons de la souris                              ||
// ||         | Shift: TShiftState                                            ||
// ||         |   etat des touches Shift et CTRL                              ||
// ||         | X, Y: Integer                                                 ||
// ||         |   position de la souris                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var i : integer;
begin
  SetFocus ;

  // **************************************************************************
  // * Sauvegarde de la position de la souris sur l'entit                    *
  // **************************************************************************

  if not(sender is TfrmEntite) then
  begin
    MousePoint.X:=(sender as tcontrol).left + X;
    MousePoint.Y:=(sender as TControl ).top + Y;
  end else
  begin
    MousePoint.X:= X;
    MousePoint.Y:= Y;
  end;

  // **************************************************************************
  // * Affichage de la selection                                              *
  // **************************************************************************

  self.begindrag(false,intDistanceAvantDrag);
  Tfrmmaitre(Parent).entiteSelection := self;
  for i := 0 to Tfrmmaitre(Parent).ControlCount -1 do
    if Tfrmmaitre(Parent).controls[i] is TfrmEntite then
      TfrmEntite (Tfrmmaitre(Parent).controls[i]).dessinerSelection(TfrmEntite (Tfrmmaitre(Parent).controls[i]) =  Tfrmmaitre(Parent).entiteSelection);
end;

function TfrmEntite.getNom : string;

//  ___________________________________________________________________________
// | function TfrmEntite.getNom                                                |
// | _________________________________________________________________________ |
// || permet de retourner le Hostname de l'entit                             ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : string                                               ||
// ||         |   nom de l'entit                                             ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := information.strNom ;
end;

function TfrmEntite.getstrType : string;

//  ___________________________________________________________________________
// | function TfrmEntite.getstrType                                            |
// | _________________________________________________________________________ |
// || permet de retourner le type de l'entit sous forme litteral             ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : string                                               ||
// ||         |   nom du type d'entit                                        ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  case information.typeMachine of
    tmImprimante : result := 'l''imprimante';
    tmOrdinateur : result := 'l''ordinateur';
    tmServeur    : result := 'le serveur';
    tmSwitch     : result := 'le switch';
  end;
end;

function TfrmEntite.getInfo : Tmachine ;

//  ___________________________________________________________________________
// | function TfrmEntite.getInfo                                               |
// | _________________________________________________________________________ |
// || Permet de retourner les informations                                    ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : tinformation                                         ||
// ||         |   information de l'entit                                     ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  information.x := left;
  information.y := top ;
  result := information;
end;

function TfrmEntite.getBooControler  : boolean ;

//  ___________________________________________________________________________
// | function TfrmEntite.getBooControler                                       |
// | _________________________________________________________________________ |
// || Permet de retourn la valeur de booControler                            ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | result : boolean                                              ||
// ||         |   valeur de booControler                                      ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := information.booControler ;
end;

procedure TfrmEntite.fDblClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmEntite.fDblClick                                            |
// | _________________________________________________________________________ |
// || Permet d'afficher les proprit de l'entit et de les modifier          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procdure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  timer1.Enabled := true;     // passe par un timer pour ouvrir TfrmSaisie ou sinon l'entit reste en dplacement apres
end;

procedure TfrmEntite.Timer1Timer(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmEntite.Timer1Timer                                          |
// | _________________________________________________________________________ |
// ||                                                                         ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procdure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  timer1.Enabled := false;
  if TfrmSaisie.modifiInformation (information) then
  begin
    lblIP.caption := information.strhost;
    lblNom.Caption := information.strNom;
    image1.Picture := nil;
    ImageList1.GetBitmap(ord(information.typeMachine),Image1.Picture.Bitmap );
    image1.Refresh ;
    adaptetaille ;
    modifierHint;
    name := StringReplace(information.strNom,' ','_',[rfReplaceAll , rfIgnoreCase ]);
    ping.SetAddress(information.strhost);
  end;
end;

initialization
  nbentite :=0;
  intDistanceAvantDrag := 0;
  intTaillegrille := 1 ;
  strmessage := '';


end.
