unit ufrmSaisie;

// |===========================================================================|
// | unit ufrmSaisie                                                           |
// | Copyright  2007 F.BASSO                                                  |
// |___________________________________________________________________________|
// | Unit de saisie des informations pour le Logiciel fbping                  |
// | Permet de modifier ou de crer une nouvelle entit                        |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0  cration de l'unit                                              |
// |===========================================================================|

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,ufrmEntite;

type
  TfrmSaisie = class(TForm)
    cbxType: TComboBox;
    editNom: TEdit;
    editHost: TEdit;
    editcommentaire: TEdit;
    cbxMonitoring: TCheckBox;
    cmdOk: TBitBtn;
    cmdCancel: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Change(Sender: TObject);
    procedure cbxMonitoringClick(Sender: TObject);
  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

    class function getInformation (var machine : Tmachine) : boolean ;
    class function modifiInformation (var machine : Tmachine) : boolean ;
  end;

var
  frmSaisie: TfrmSaisie;

implementation

{$R *.dfm}

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Publiques                                                          #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#


class function tfrmsaisie.getInformation (var machine : Tmachine): Boolean ;

//  ___________________________________________________________________________
// | class function tfrmsaisie.getInformation                                  |
// | _________________________________________________________________________ |
// || permet de crer une nouvelle entit                                     ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties | var machine : Tmachine                                        ||
// ||         |   informations concernant la nouvelle entit                  ||
// ||         | Result : boolean                                              ||
// ||         |   vrai si validation                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := false;
  if not Assigned(frmSaisie) then
    frmSaisie := TfrmSaisie.Create(Application );
  with frmsaisie do
  begin
    if ShowModal = mrok then
    begin
      result := true;
      machine.typeMachine := ttypemachine ( cbxType.ItemIndex );
      machine.strNom := editNom.Text;
      machine.strHost := editHost.Text ;
      machine.strCommentaire := editcommentaire.Text ;
      machine.booControler := cbxMonitoring.Checked ;
      machine.x := 80;
      machine.y := 0;
    end;
  end;
end;

class function tfrmsaisie.modifiInformation (var machine : Tmachine): Boolean ;

//  ___________________________________________________________________________
// | class function tfrmsaisie.modifiInformation                               |
// | _________________________________________________________________________ |
// || methode de class permetant de modifier les information de l'entit      ||
// ||_________________________________________________________________________||
// || Entres | var machine : Tmachine                                        ||
// ||         |   informations d'origine                                      ||
// ||_________|_______________________________________________________________||
// || Sorties | var machine : Tmachine                                        ||
// ||         |   informations modifies                                      ||
// ||         | result : boolean                                              ||
// ||         |   Vrai si modifications                                       ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  result := false;
  if not Assigned(frmSaisie) then
    frmSaisie := TfrmSaisie.Create(Application );
  with frmSaisie do
  begin
    editNom.Text := machine.strNom ;
    editHost.Text := machine.strHost ;
    editcommentaire.Text := machine.strCommentaire ;
    cbxType.ItemIndex := ord (machine.typeMachine );
    cbxMonitoring.Checked := machine.booControler ;
    result :=tfrmsaisie.getInformation(machine);
  end;
end;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Evenementielle                                                     #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TfrmSaisie.cbxMonitoringClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmSaisie.cbxMonitoringClick                                   |
// | _________________________________________________________________________ |
// || Permet d'vit qu'il y ait surveillance de l'entit s'il n'y a pas @ip  ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if cbxMonitoring.Checked then
  if editHost.Text ='' then
    cbxMonitoring.Checked := false;
  change(nil);
end;


procedure TfrmSaisie.Change(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmSaisie.Change                                               |
// | _________________________________________________________________________ |
// || Premet d'activer le bouton OK quand il y a quelque chose dans les champs||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   objet appelant la procedure                                 ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  cmdOk.Enabled := (editNom.Text <>'') and (cbxType.Itemindex <> -1)
end;

end.
